
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned int len);
int snprintf(char *str, unsigned int size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned int size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#pragma used+

void Nokia_initlcd(void);                    
void Nokia_writecom(char);                
void Nokia_write_data(char);                
void Nokia_write_reg(char,char);
void Nokia_clockdata(char);                
void Nokia_clearram(void);                
void Nokia_cursorxy(char,char);            
void Nokia_putchar(char);                    

void Nokia_putstrf(char flash *);            
void Nokia_putstr(char  *);

void Nokia_putnum_megafont( char , char, char );

flash static const char font5x7[256][5] = {
{0x00, 0x00, 0x00, 0x00, 0x00},
{0x00, 0x00, 0x5F, 0x00, 0x00},
{0x00, 0x07, 0x00, 0x07, 0x00},
{0x14, 0x7F, 0x14, 0x7F, 0x14},
{0x24, 0x2A, 0x7F, 0x2A, 0x12},
{0x23, 0x13, 0x08, 0x64, 0x62},
{0x36, 0x49, 0x55, 0x22, 0x50},
{0x00, 0x05, 0x03, 0x00, 0x00},
{0x00, 0x1C, 0x22, 0x41, 0x00},
{0x00, 0x41, 0x22, 0x1C, 0x00},
{0x14, 0x08, 0x3E, 0x08, 0x14},
{0x08, 0x08, 0x3E, 0x08, 0x08},
{0x00, 0x50, 0x30, 0x00, 0x00},
{0x08, 0x08, 0x08, 0x08, 0x08},
{0x00, 0x60, 0x60, 0x00, 0x00},
{0x20, 0x10, 0x08, 0x04, 0x02},
{0x00, 0x00, 0x00, 0x00, 0x00},
{0x00, 0x00, 0x5F, 0x00, 0x00},
{0x00, 0x07, 0x00, 0x07, 0x00},
{0x14, 0x7F, 0x14, 0x7F, 0x14},
{0x24, 0x2A, 0x7F, 0x2A, 0x12},
{0x23, 0x13, 0x08, 0x64, 0x62},
{0x36, 0x49, 0x55, 0x22, 0x50},
{0x00, 0x05, 0x03, 0x00, 0x00},
{0x00, 0x1C, 0x22, 0x41, 0x00},
{0x00, 0x41, 0x22, 0x1C, 0x00},
{0x14, 0x08, 0x3E, 0x08, 0x14},
{0x08, 0x08, 0x3E, 0x08, 0x08},
{0x00, 0x50, 0x30, 0x00, 0x00},
{0x08, 0x08, 0x08, 0x08, 0x08},
{0x00, 0x60, 0x60, 0x00, 0x00},
{0x20, 0x10, 0x08, 0x04, 0x02},
{0x00, 0x00, 0x00, 0x00, 0x00},
{0x00, 0x00, 0x5F, 0x00, 0x00},
{0x00, 0x07, 0x00, 0x07, 0x00},
{0x14, 0x7F, 0x14, 0x7F, 0x14},
{0x24, 0x2A, 0x7F, 0x2A, 0x12},
{0x06, 0x84, 0xFE, 0x84, 0x06},
{0x36, 0x49, 0x55, 0x22, 0x50},
{0x00, 0x05, 0x03, 0x00, 0x00},
{0x00, 0x1C, 0x22, 0x41, 0x00},
{0x00, 0x7F, 0x3E, 0x1C, 0x08},
{0x14, 0x08, 0x3E, 0x08, 0x14},
{0x08, 0x08, 0x3E, 0x08, 0x08},
{0x00, 0x50, 0x30, 0x00, 0x00},
{0x08, 0x08, 0x08, 0x08, 0x08},
{0x00, 0x60, 0x60, 0x00, 0x00},
{0x20, 0x10, 0x08, 0x04, 0x02},
{0x3E, 0x51, 0x49, 0x45, 0x3E},
{0x00, 0x42, 0x7F, 0x40, 0x00},
{0x42, 0x61, 0x51, 0x49, 0x46},
{0x21, 0x41, 0x45, 0x4B, 0x31},
{0x18, 0x14, 0x12, 0x7F, 0x10},
{0x27, 0x45, 0x45, 0x45, 0x39},
{0x3C, 0x4A, 0x49, 0x49, 0x30},
{0x01, 0x71, 0x09, 0x05, 0x03},
{0x36, 0x49, 0x49, 0x49, 0x36},
{0x06, 0x49, 0x49, 0x29, 0x1E},
{0x00, 0x36, 0x36, 0x00, 0x00},
{0x00, 0x56, 0x36, 0x00, 0x00},
{0x08, 0x14, 0x22, 0x41, 0x00},
{0x14, 0x14, 0x14, 0x14, 0x14},
{0x00, 0x41, 0x22, 0x14, 0x08},
{0x02, 0x01, 0x51, 0x09, 0x06},
{0x32, 0x49, 0x79, 0x41, 0x3E},
{0x7E, 0x11, 0x11, 0x11, 0x7E},
{0x7F, 0x49, 0x49, 0x49, 0x36},
{0x3E, 0x41, 0x41, 0x41, 0x22},
{0x7F, 0x41, 0x41, 0x22, 0x1C},
{0x7F, 0x49, 0x49, 0x49, 0x41},
{0x7F, 0x09, 0x09, 0x09, 0x01},
{0x3E, 0x41, 0x49, 0x49, 0x7A},
{0x7F, 0x08, 0x08, 0x08, 0x7F},
{0x00, 0x41, 0x7F, 0x41, 0x00},
{0x20, 0x40, 0x41, 0x3F, 0x01},
{0x7F, 0x08, 0x14, 0x22, 0x41},
{0x7F, 0x40, 0x40, 0x40, 0x40},
{0x7F, 0x02, 0x0C, 0x02, 0x7F},
{0x7F, 0x04, 0x08, 0x10, 0x7F},
{0x3E, 0x41, 0x41, 0x41, 0x3E},
{0x7F, 0x09, 0x09, 0x09, 0x06},
{0x3E, 0x41, 0x51, 0x21, 0x5E},
{0x7F, 0x09, 0x19, 0x29, 0x46},
{0x46, 0x49, 0x49, 0x49, 0x31},
{0x01, 0x01, 0x7F, 0x01, 0x01},
{0x3F, 0x40, 0x40, 0x40, 0x3F},
{0x1F, 0x20, 0x40, 0x20, 0x1F},
{0x3F, 0x40, 0x38, 0x40, 0x3F},
{0x63, 0x14, 0x08, 0x14, 0x63},
{0x07, 0x08, 0x70, 0x08, 0x07},
{0x61, 0x51, 0x49, 0x45, 0x43},
{0x00, 0x7F, 0x41, 0x41, 0x00},
{0x02, 0x04, 0x08, 0x10, 0x20},
{0x00, 0x41, 0x41, 0x7F, 0x00},
{0x04, 0x02, 0x01, 0x02, 0x04},
{0x40, 0x40, 0x40, 0x40, 0x40},
{0x00, 0x01, 0x02, 0x04, 0x00},
{0x20, 0x54, 0x54, 0x54, 0x78},
{0x7F, 0x48, 0x44, 0x44, 0x38},
{0x38, 0x44, 0x44, 0x44, 0x20},
{0x38, 0x44, 0x44, 0x48, 0x7F},
{0x38, 0x54, 0x54, 0x54, 0x18},
{0x08, 0x7E, 0x09, 0x01, 0x02},
{0x0C, 0x52, 0x52, 0x52, 0x3E},
{0x7F, 0x08, 0x04, 0x04, 0x78},
{0x00, 0x44, 0x7D, 0x40, 0x00},
{0x20, 0x40, 0x44, 0x3D, 0x00},
{0x7F, 0x10, 0x28, 0x44, 0x00},
{0x00, 0x41, 0x7F, 0x40, 0x00},
{0x7C, 0x04, 0x18, 0x04, 0x78},
{0x7C, 0x08, 0x04, 0x04, 0x78},
{0x38, 0x44, 0x44, 0x44, 0x38},
{0x7C, 0x14, 0x14, 0x14, 0x08},
{0x08, 0x14, 0x14, 0x18, 0x7C},
{0x7C, 0x08, 0x04, 0x04, 0x08},
{0x48, 0x54, 0x54, 0x54, 0x20},
{0x04, 0x3F, 0x44, 0x40, 0x20},
{0x3C, 0x40, 0x40, 0x20, 0x7C},
{0x1C, 0x20, 0x40, 0x20, 0x1C},
{0x3C, 0x40, 0x30, 0x40, 0x3C},
{0x44, 0x28, 0x10, 0x28, 0x44},
{0x0C, 0x50, 0x50, 0x50, 0x3C},
{0x44, 0x64, 0x54, 0x4C, 0x44},
{0x00, 0x08, 0x36, 0x41, 0x00},
{0x00, 0x00, 0x7F, 0x00, 0x00},
{0x00, 0x41, 0x36, 0x08, 0x00},
{0x10, 0x08, 0x08, 0x10, 0x08},
{0x78, 0x46, 0x41, 0x46, 0x78},
{0x00, 0x00, 0x00, 0x00, 0x00},
{0x00, 0x00, 0x5F, 0x00, 0x00},
{0x00, 0x07, 0x00, 0x07, 0x00},
{0x14, 0x7F, 0x14, 0x7F, 0x14},
{0x24, 0x2A, 0x7F, 0x2A, 0x12},
{0x23, 0x13, 0x08, 0x64, 0x62},
{0x36, 0x49, 0x55, 0x22, 0x50},
{0x00, 0x05, 0x03, 0x00, 0x00},
{0x00, 0x1C, 0x22, 0x41, 0x00},
{0x00, 0x41, 0x22, 0x1C, 0x00},
{0x14, 0x08, 0x3E, 0x08, 0x14},
{0x08, 0x08, 0x3E, 0x08, 0x08},
{0x00, 0x50, 0x30, 0x00, 0x00},
{0x08, 0x08, 0x08, 0x08, 0x08},
{0x00, 0x60, 0x60, 0x00, 0x00},
{0x20, 0x10, 0x08, 0x04, 0x02},
{0x00, 0x00, 0x00, 0x00, 0x00},
{0x00, 0x00, 0x5F, 0x00, 0x00},
{0x00, 0x07, 0x00, 0x07, 0x00},
{0x14, 0x7F, 0x14, 0x7F, 0x14},
{0x24, 0x2A, 0x7F, 0x2A, 0x12},
{0x23, 0x13, 0x08, 0x64, 0x62},
{0x36, 0x49, 0x55, 0x22, 0x50},
{0x00, 0x05, 0x03, 0x00, 0x00},
{0x00, 0x1C, 0x22, 0x41, 0x00},
{0x00, 0x41, 0x22, 0x1C, 0x00},
{0x14, 0x08, 0x3E, 0x08, 0x14},
{0x08, 0x08, 0x3E, 0x08, 0x08},
{0x00, 0x50, 0x30, 0x00, 0x00},
{0x08, 0x08, 0x08, 0x08, 0x08},
{0x00, 0x60, 0x60, 0x00, 0x00},
{0x20, 0x10, 0x08, 0x04, 0x02},
{0x00, 0x00, 0x00, 0x00, 0x00},
{0x00, 0x00, 0x5F, 0x00, 0x00},
{0x00, 0x07, 0x00, 0x07, 0x00},
{0x14, 0x7F, 0x14, 0x7F, 0x14},
{0x24, 0x2A, 0x7F, 0x2A, 0x12},
{0x23, 0x13, 0x08, 0x64, 0x62},
{0x36, 0x49, 0x55, 0x22, 0x50},
{0x00, 0x05, 0x03, 0x00, 0x00},
{0x00, 0x1C, 0x22, 0x41, 0x00},
{0x00, 0x41, 0x22, 0x1C, 0x00},
{0x14, 0x08, 0x3E, 0x08, 0x14},
{0x08, 0x08, 0x3E, 0x08, 0x08},
{0x00, 0x50, 0x30, 0x00, 0x00},
{0x08, 0x08, 0x08, 0x08, 0x08},
{0x00, 0x60, 0x60, 0x00, 0x00},
{0x20, 0x10, 0x08, 0x04, 0x02},
{0x3E, 0x51, 0x49, 0x45, 0x3E},
{0x00, 0x42, 0x7F, 0x40, 0x00},
{0x42, 0x61, 0x51, 0x49, 0x46},
{0x21, 0x41, 0x45, 0x4B, 0x31},
{0x18, 0x14, 0x12, 0x7F, 0x10},
{0x27, 0x45, 0x45, 0x45, 0x39},
{0x3C, 0x4A, 0x49, 0x49, 0x30},
{0x01, 0x71, 0x09, 0x05, 0x03},
{0x36, 0x49, 0x49, 0x49, 0x36},
{0x06, 0x49, 0x49, 0x29, 0x1E},
{0x00, 0x36, 0x36, 0x00, 0x00},
{0x00, 0x56, 0x36, 0x00, 0x00},
{0x08, 0x14, 0x22, 0x41, 0x00},
{0x14, 0x14, 0x14, 0x14, 0x14},
{0x00, 0x41, 0x22, 0x14, 0x08},
{0x02, 0x01, 0x51, 0x09, 0x06},
{0x7E, 0x11, 0x11, 0x11, 0x7E},
{0x7F, 0x49, 0x49, 0x49, 0x31},
{0x7F, 0x49, 0x49, 0x49, 0x36},
{0x7F, 0x01, 0x01, 0x01, 0x03},
{0x70, 0x29, 0x27, 0x21, 0x7F},
{0x7F, 0x49, 0x49, 0x49, 0x41},
{0x77, 0x08, 0x7F, 0x08, 0x77},
{0x41, 0x41, 0x41, 0x49, 0x76},
{0x7F, 0x10, 0x08, 0x04, 0x7F},
{0x7F, 0x10, 0x09, 0x04, 0x7F},
{0x7F, 0x08, 0x14, 0x22, 0x41},
{0x20, 0x41, 0x3F, 0x01, 0x7F},
{0x7F, 0x02, 0x0C, 0x02, 0x7F},
{0x7F, 0x08, 0x08, 0x08, 0x7F},
{0x3E, 0x41, 0x41, 0x41, 0x3E},
{0x7F, 0x01, 0x01, 0x01, 0x7F},
{0x7F, 0x09, 0x09, 0x09, 0x06},
{0x3E, 0x41, 0x41, 0x41, 0x22},
{0x01, 0x01, 0x7F, 0x01, 0x01},
{0x47, 0x28, 0x10, 0x08, 0x07},
{0x1E, 0x21, 0x7F, 0x21, 0x1E},
{0x63, 0x14, 0x08, 0x14, 0x63},
{0x3F, 0x20, 0x20, 0x20, 0x5F},
{0x07, 0x08, 0x08, 0x08, 0x7F},
{0x7F, 0x40, 0x7F, 0x40, 0x7F},
{0x3F, 0x20, 0x3F, 0x20, 0x5F},
{0x01, 0x7F, 0x48, 0x48, 0x30},
{0x7F, 0x48, 0x30, 0x00, 0x7F},
{0x00, 0x7F, 0x48, 0x48, 0x30},
{0x41, 0x41, 0x41, 0x49, 0x3E},
{0x7F, 0x08, 0x3E, 0x41, 0x3E},
{0x46, 0x29, 0x19, 0x09, 0x7F},
{0x20, 0x54, 0x54, 0x54, 0x78},
{0x3C, 0x4A, 0x4A, 0x49, 0x31},
{0x7C, 0x54, 0x54, 0x28, 0x00},
{0x7C, 0x04, 0x04, 0x04, 0x0C},
{0x72, 0x2A, 0x26, 0x22, 0x7E},
{0x38, 0x54, 0x54, 0x54, 0x18},
{0x6C, 0x10, 0x7C, 0x10, 0x6C},
{0x44, 0x44, 0x54, 0x54, 0x38},
{0x7C, 0x20, 0x10, 0x08, 0x7C},
{0x7C, 0x21, 0x12, 0x09, 0x7C},
{0x7C, 0x10, 0x28, 0x44, 0x00},
{0x20, 0x44, 0x3C, 0x04, 0x7C},
{0x7C, 0x08, 0x10, 0x08, 0x7C},
{0x7C, 0x10, 0x10, 0x10, 0x7C},
{0x38, 0x44, 0x44, 0x44, 0x38},
{0x7C, 0x04, 0x04, 0x04, 0x7C},
{0x7C, 0x14, 0x14, 0x14, 0x08},
{0x38, 0x44, 0x44, 0x44, 0x20},
{0x04, 0x04, 0x7C, 0x04, 0x04},
{0x44, 0x28, 0x10, 0x08, 0x04},
{0x08, 0x14, 0x7E, 0x14, 0x08},
{0x44, 0x28, 0x10, 0x28, 0x44},
{0x3C, 0x40, 0x40, 0x7C, 0x40},
{0x0C, 0x10, 0x10, 0x10, 0x7C},
{0x7C, 0x40, 0x7C, 0x40, 0x7C},
{0x3C, 0x20, 0x3C, 0x20, 0x7C},
{0x04, 0x7C, 0x50, 0x50, 0x20},
{0x7C, 0x50, 0x20, 0x00, 0x7C},
{0x00, 0x7C, 0x50, 0x50, 0x20},
{0x28, 0x44, 0x44, 0x54, 0x38},
{0x7C, 0x10, 0x38, 0x44, 0x38},
{0x48, 0x54, 0x34, 0x14, 0x7C} 
} ;

static const char number [][2][10]=
{

{{   0xF0, 0xFC, 0xFE, 0x03, 0x01, 0x01, 0x03, 0xFE, 0xFC, 0xF0    },
{   0x0F, 0x3F, 0x7F, 0xC0, 0x80, 0x80, 0xC0, 0x7F, 0x3F, 0x0F   }}, 
{{   0x00, 0x01, 0x01, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00    },
{   0x80, 0x80, 0x80, 0xFF, 0xFF, 0xFF, 0x80, 0x80, 0x80, 0x00   }}, 
{{   0x1C, 0x3A, 0x39, 0x01, 0x01, 0x01, 0x03, 0xFE, 0xFE, 0x38   } ,
{   0xE0, 0xE0, 0xF0, 0xE8, 0xE4, 0xE2, 0xE3, 0xE1, 0xE0, 0xF8    }}, 
{{   0x0E, 0x8E, 0x8D, 0x81, 0x81, 0xC1, 0x43, 0x7E, 0x3E, 0x1C   },
{   0x38, 0x78, 0xB8, 0x80, 0x80, 0x80, 0xC1, 0x7F, 0x7E, 0x3E   }}, 
{{   0x00, 0x00, 0x00, 0xC0, 0x20, 0x10, 0xFC, 0xFE, 0xFF, 0x00   },
{   0x0C, 0x0A, 0x09, 0x08, 0x88, 0x88, 0xFF, 0xFF, 0xFF, 0x88   }}, 
{{   0x00, 0xFF, 0x47, 0x47, 0x47, 0x47, 0xC7, 0x87, 0x87, 0x03    },
{   0x38, 0x78, 0xB8, 0x80, 0x80, 0x80, 0xC0, 0x7F, 0x3F, 0x1E   }}, 
{{   0xC0, 0xF0, 0xF8, 0x9C, 0x46, 0x42, 0x43, 0x81, 0x81, 0x00    },
{   0x0F, 0x3F, 0x7F, 0xC0, 0x80, 0x80, 0xC0, 0x7F, 0x3F, 0x1E   }}, 
{{   0x1C, 0x0F, 0x07, 0x07, 0x07, 0xC7, 0x27, 0x1F, 0x07, 0x03  },
{   0x00, 0x00, 0x70, 0xFC, 0xFF, 0x70, 0x00, 0x00, 0x00, 0x00   }}, 
{{   0x3C, 0x3E, 0x7F, 0xC3, 0x81, 0x81, 0x41, 0x7F, 0x3E, 0x1C    },
{   0x3C, 0x7F, 0xFF, 0xC1, 0x80, 0x80, 0xC1, 0xFF, 0x7F, 0x3C  }}, 
{{   0x78, 0xFE, 0xFE, 0x03, 0x01, 0x01, 0x03, 0xFE, 0xFC, 0xF0    },
{   0x00, 0x81, 0xC1, 0xC2, 0x62, 0x3A, 0x1D, 0x0F, 0x03, 0x00  }} 

};

#pragma used-

#pragma library 3310.lib

#asm
   .equ __i2c_port=0x15 ;PORTC
   .equ __sda_bit=0
   .equ __scl_bit=1
#endasm

#pragma used+
void i2c_init(void);
unsigned char i2c_start(void);
void i2c_stop(void);
unsigned char i2c_read(unsigned char ack);
unsigned char i2c_write(unsigned char data);
#pragma used-

typedef unsigned char u8_t;
typedef unsigned int u16_t;
typedef unsigned long int u32_t;

void main(void)
{

DDRB=0xFF; 

ACSR=0x80;

i2c_init();

Nokia_initlcd();

Nokia_putnum_megafont (5 ,54 , 1);

}
